using UnityEngine;

namespace Mod
{
	public class Mod
	{
		public static void Main()
		{
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "Norinco Type 56-1",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Chinese 7.62×39mm rifle that is a variant of the Soviet-designed AK-47",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Norinco-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var NorincoSlide = Instance.transform.Find("Slide");
                        NorincoSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/NorincoSlide.png", 2.5f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Norinco.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
						
						customCartridge.name = "Norinco - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(0f,0.1f);
						
						var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Sprites/NorincoCover.png", 2.5f);
                        childSprite.sortingLayerName = "Top";
						
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/Norinco.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.6300f, 0.1000f);
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
			}
                }
            );

            ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "Colt Commando",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "M16-based carbine",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Commando-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var CommandoSlide = Instance.transform.Find("Slide");
                        CommandoSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Commandoslide.png", 2.5f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Commando.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
						
						customCartridge.name = "Commando - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(0f,0.1f);
						
						var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Sprites/CommandoCover.png", 2.5f);
                        childSprite.sortingLayerName = "Top";
						
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/Commando.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.5200f, 0.0900f);
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.08f;
			}
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "H&K G36K",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Assault rifle designed in the early 1990s by German company Heckler & Koch",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/G36K-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var G36KSlide = Instance.transform.Find("Slide");
                        G36KSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/G36KSlide.png", 2.5f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/G36K.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
						
						customCartridge.name = "G36K - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(0f,0.1f);
						
						var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Sprites/G36Kcover.png", 2.5f);
                        childSprite.sortingLayerName = "Top";
						
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/G36K.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.6100f, 0.0800f);
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.085f;
			}
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "SG 550",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Assault rifle manufactured by Swiss Arms AG",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/SG-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var SGSlide = Instance.transform.Find("Slide");
                        SGSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/SGSlide.png", 2.5f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/SG550.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
						
						customCartridge.name = "SG - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.1f,0.1f);
						
						var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Sprites/SGcover.png", 2.5f);
                        childSprite.sortingLayerName = "Top";
						
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/SG.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.7100f, 0.0950f);
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.09f;
			}
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "StG 44",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "German selective-fire assault rifle developed during World War II",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/STG-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var STGSlide = Instance.transform.Find("Slide");
                        STGSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/STGSlide.png", 2.5f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/STG44.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
						
						customCartridge.name = "STG - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(0f,0.1f);
						
						var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Sprites/STGCover.png", 2.5f);
                        childSprite.sortingLayerName = "Top";
						
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/STG.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.7100f, 0.125f);
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.12f;
			}
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "FN FAL",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Battle rifle designed by Belgian small arms designer Dieudonné Saive and manufactured by FN Herstal",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/FAL-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var FALSlide = Instance.transform.Find("Slide");
                        FALSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/FNFALSlide.png", 2.5f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/FNFAL.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("7.62x51mm");
						
						customCartridge.name = "FAL - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.1f,0.1f);
						
						var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Sprites/FNFALCover.png", 2.5f);
                        childSprite.sortingLayerName = "Top";
						
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/FNFAL.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.8350f, 0.075f);
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
			}
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "SKS",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Soviet semi-automatic rifle designed in 1943",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/SKS-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var SKSSlide = Instance.transform.Find("Slide");
                        SKSSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/SKSSlide.png", 2.5f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/SKS.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
						
						customCartridge.name = "SKS - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.05f,0.1f);
						
						var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Sprites/SKSCover.png", 2.5f);
                        childSprite.sortingLayerName = "Top";
						
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/SKS.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.7900f, 0.08f);
			}
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "Ruger Mini-30",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Semi-automatic rifle manufactured by Ruger",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Ruger-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var RugerSlide = Instance.transform.Find("Slide");
                        RugerSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Rugerslide.png", 2.5f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Ruger.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
						
						customCartridge.name = "Ruger - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(0f,0.1f);
						
						var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Sprites/Rugercover.png", 2.5f);
                        childSprite.sortingLayerName = "Top";
						
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/Ruger.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.6900f, 0.11f);
			}
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "Browning Bar",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Gas-operated, semi-automatic rifle produced by the Browning Arms Company in Belgium",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Bar-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var BarSlide = Instance.transform.Find("Slide");
                        BarSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Barslide.png", 2.5f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Bar.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("7.62x51mm");
						
						customCartridge.name = "Bar - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.8f;
						
						firearm.casingPosition = new Vector3(-0.05f,0.1f);
						
						var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Sprites/Barcover.png", 2.5f);
                        childSprite.sortingLayerName = "Top";
						
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/Bar.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.7450f, 0.115f);
			}
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "SVD",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Semi-automatic designated marksman rifle developed in the Soviet Union",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/SVD-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var SVDSlide = Instance.transform.Find("Slide");
                        SVDSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/SVDslide.png", 2.5f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/SVD.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("7.62x51mm");
						
						customCartridge.name = "SVD - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.5f;
						
						firearm.casingPosition = new Vector3(-0.2f,0.1f);
						
						var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Sprites/SVDcover.png", 2.5f);
                        childSprite.sortingLayerName = "Top";
						
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/SVD.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.8800f, 0.01f);
			}
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "PSG-1",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Semi-automatic sniper rifle designed and produced by the German company Heckler & Koch",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/PSG-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var PSGSlide = Instance.transform.Find("Slide");
                        PSGSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/PSGslide.png", 2.5f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/PSG.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("7.62x51mm");
						
						customCartridge.name = "PSG - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.5f;
						
						firearm.casingPosition = new Vector3(-0.1f,0.1f);
						
						var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Sprites/PSGCover.png", 2.5f);
                        childSprite.sortingLayerName = "Top";
						
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/PSG.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.8800f, 0.045f);
			}
                }
            );
			
			ModAPI.Register(
			    new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
					NameOverride = "VSS Vintorez ",
					NameToOrderByOverride = "F#8",
					DescriptionOverride = "Sniper rifle counterpart to the AS Val assault rifle",
					CategoryOverride = ModAPI.FindCategory("Firearms"),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/VSS-thumb.png"),
					AfterSpawn = (Instance) =>
					{
						ModAPI.KeepExtraObjects();
						
						var VSSSlide = Instance.transform.Find("Slide");
                        VSSSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/VSSslide.png", 2.5f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/VSS.png", 2.5f);
						
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						
						Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
						
						customCartridge.name = "VSS - Cartridge";
						
						customCartridge.Damage *= 0.75f;
						
						customCartridge.StartSpeed *= 1.5f;
						
						customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
						
						customCartridge.Recoil *= 0.7f;
						
						customCartridge.ImpactForce *= 0.5f;
						
						firearm.casingPosition = new Vector3(0f,0.1f);
						
						var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Sprites/VSSCover.png", 2.5f);
                        childSprite.sortingLayerName = "Top";
						
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Sounds/VSS.mp3"),

						}
						;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.6500f, 0.005f);
			}
                }
            );
        }
    }
}